Description

I was looking at the project identifier constraint today and noticed a discrepancy between:

the text of text_project_identifier_info (Only lower case letters (a-z), numbers, dashes and underscores are allowed, must start

with a lower case letter.<br />Once saved, the identifier cannot be changed.)

the auto-generated identifiers from #9225

and the actual enforced model constraint for the project identifier (/\A(?!\d+$)[a-z0-9\-_]*\z/).

Based on the model constraint, project identifiers starting with a:

number

dash

underscore

are allowed and seem to work properly. This can be tested by adding the following test assertions to

ProjectTest#test_validate_identifier:

diff --git a/test/unit/project_test.rb b/test/unit/project_test.rb

index 24f6958..a0bd95f 100644

--- a/test/unit/project_test.rb

+++ b/test/unit/project_test.rb

@@ -116,7 +116,10 @@ class ProjectTest < ActiveSupport::TestCase

                "ab-12" => true,

                "ab_12" => true,

                "12" => false,

-               "new" => false}

+               "new" => false,

+               "12ab" => true,

+               "-12ab" => true,

+               "_12ab" => true}

     to_test.each do |identifier, valid|

       p = Project.new

 Despite the textual hint and the auto-generated project identifiers, the above given test assertions succeed without any problems.

IMO there are two ways of solving this:

1. change the model constraint to match the textual hint and JS-project identifier generation script — that is to not allow project

identifiers starting with a number, dash or underscore;

2. change the textual hint and JS-project identifier generation script to match the actual model constraint — which is to allow

project identifiers starting with a number, dash or underscore.

I think that the second solution is the best, because that won't affect already existing projects with identifiers starting with these

characters. I'd like to get some feedback on this matter before we make a change either way.

Related issues:

Related to Redmine - Patch #9225: Generate project identifier automatically w... Closed 2011-09-11
https://www.redmine.org/issues/9225


Associated revisions

Revision 17963 - 2019-03-15 10:26 - Jean-Philippe Lang

Reverts r11130 and r11132 (#9225).

History

#1 - 2017-09-29 17:24 - Mischa The Evil

- Related to Patch #9225: Generate project identifier automatically with JavaScript added

#2 - 2017-10-29 12:05 - Toshi MARUYAMA

- Target version set to 4.1.0

#3 - 2019-03-15 10:30 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Thanks for pointing this out. I've updated the information messages that were obviously wrong.

OTOH, I think it's OK to keep the JS code as it is. Even if not mandatory, it's better to default to an identifier that starts with a lower case letter.
